import { __decorate, __param } from 'tslib';
import { ViewChild, Input, Component, Host, Renderer2, ElementRef, ComponentFactoryResolver, ViewContainerRef, Directive, NgModule } from '@angular/core';
import { NgbCalendar, NgbInputDatepicker } from '@ng-bootstrap/ng-bootstrap';

let DayComponent = class DayComponent {
    constructor(calendar) {
        this.calendar = calendar;
        this.highlightWeekend = false;
        this.isDisabled = (date, current) => date.month !== current.month;
        this.isWeekend = (date) => this.calendar.getWeekday(date) >= 6;
    }
};
DayComponent.ctorParameters = () => [
    { type: NgbCalendar }
];
__decorate([
    ViewChild('defaultDayTemplate', { static: true })
], DayComponent.prototype, "defaultDayTemplate", void 0);
__decorate([
    Input()
], DayComponent.prototype, "highlightWeekend", void 0);
DayComponent = __decorate([
    Component({
        selector: 'app-day',
        template: " \n\n  <ng-template #defaultDayTemplate let-date let-currentMonth=\"currentMonth\" let-selected=\"selected\" let-disabled=\"disabled\" let-focused=\"focused\">\n    <span class=\"custom-day\" [class.weekend]=\"highlightWeekend && isWeekend(date)\" [class.disabled]=\"isWeekend(date)\" [class.focused]=\"focused\"\n          [class.bg-primary]=\"selected\" [class.outside]=\"date.month !== currentMonth\" [class.text-muted]=\"date.month !== currentMonth\">\n      {{ date.day }}\n    </span>\n  </ng-template>",
        styles: [".custom-day{text-align:center;padding:.185rem .25rem;border-radius:.25rem;display:inline-block;width:2rem}.custom-day.focused,.custom-day:hover{background-color:#e6e6e6}.weekend{border-radius:1rem;color:red}.hidden{display:none}span.disabled{border-radius:1rem}"]
    })
], DayComponent);

let CustomDatePickerDirective = class CustomDatePickerDirective {
    constructor(_picker, calendar, _renderer, _elRef, _cfr, _vcRef) {
        this._picker = _picker;
        this.calendar = calendar;
        this._renderer = _renderer;
        this._elRef = _elRef;
        this._cfr = _cfr;
        this._vcRef = _vcRef;
        this.option = {};
        this.disableWeekend = false;
        this.highlightWeekend = false;
    }
    ngOnInit() {
        debugger;
        const cf = this._cfr.resolveComponentFactory(DayComponent);
        var dayComp = this._vcRef.createComponent(cf);
        dayComp.instance.highlightWeekend = this.option.highlightWeekend;
        this._picker.dayTemplate = dayComp.instance.defaultDayTemplate;
        if (this.option.disableWeekend) {
            const isWeekendDisabled = (date, current) => this.calendar.getWeekday(date) >= 6;
            this._picker.markDisabled = isWeekendDisabled;
        }
    }
};
CustomDatePickerDirective.ctorParameters = () => [
    { type: NgbInputDatepicker, decorators: [{ type: Host }] },
    { type: NgbCalendar },
    { type: Renderer2 },
    { type: ElementRef },
    { type: ComponentFactoryResolver },
    { type: ViewContainerRef }
];
__decorate([
    Input()
], CustomDatePickerDirective.prototype, "option", void 0);
__decorate([
    Input()
], CustomDatePickerDirective.prototype, "disableWeekend", void 0);
__decorate([
    Input()
], CustomDatePickerDirective.prototype, "highlightWeekend", void 0);
CustomDatePickerDirective = __decorate([
    Directive({
        selector: `input[ngbDatepicker]`,
    }),
    __param(0, Host())
], CustomDatePickerDirective);

let BSSuperDatePickerModule = class BSSuperDatePickerModule {
};
BSSuperDatePickerModule = __decorate([
    NgModule({
        declarations: [DayComponent, CustomDatePickerDirective],
        imports: [],
        exports: [DayComponent, CustomDatePickerDirective]
    })
], BSSuperDatePickerModule);

/*
 * Public API Surface of bssuper-date-picker
 */

/**
 * Generated bundle index. Do not edit.
 */

export { BSSuperDatePickerModule, CustomDatePickerDirective, DayComponent };
//# sourceMappingURL=bssuper-date-picker.js.map
